Index: branches/HTM-15.0-dev0/source/Lib/TLibCommon/TComPic.cpp
===================================================================
--- branches/HTM-15.0-dev0/source/Lib/TLibCommon/TComPic.cpp	(revision 1316)
+++ branches/HTM-15.0-dev0/source/Lib/TLibCommon/TComPic.cpp	(revision 1317)
@@ -54,7 +54,4 @@
 , m_bReconstructed                        (false)
 , m_bNeededForOutput                      (false)
-#if NH_MV
-, m_bPicOutputFlag                        (false)
-#endif
 , m_uiCurrSliceIdx                        (0)
 , m_bCheckLTMSB                           (false)
@@ -62,4 +59,5 @@
 , m_layerId                               (0)
 , m_viewId                                (0)
+, m_bPicOutputFlag                        (false)
 #if NH_3D
 , m_viewIndex                             (0)
@@ -82,4 +80,16 @@
   m_eRapRefList       = REF_PIC_LIST_0;
   m_uiRapRefIdx       = 0;
+#endif
+#if NH_MV
+  m_isPocResettingPic = false;   
+  m_hasGeneratedRefPics = false; 
+  m_isFstPicOfAllLayOfPocResetPer = false; 
+  m_decodingOrder     = 0; 
+  m_noRaslOutputFlag  = false;  
+  m_noClrasOutputFlag = false; 
+  m_picLatencyCount   = 0; 
+  m_isGenerated       = false;
+  m_isGeneratedCl833  = false; 
+  m_activatesNewVps   = false; 
 #endif
 }
@@ -185,4 +195,5 @@
   }
 }
+
 
 Bool  TComPic::getSAOMergeAvailability(Int currAddr, Int mergeAddr)
@@ -231,100 +242,101 @@
 
 #if NH_MV
-Void TComPic::print( Bool legend )
-{
-  if ( legend )
-    std::cout  << std::endl << "LId"        << "\t" << "POC"   << "\t" << "Rec"          << "\t" << "Ref"                       << "\t" << "LT"            <<  "\t" << "OutMark" <<  "\t" << "OutFlag" << std::endl;
-  else
-    std::cout  << getLayerId() << "\t" << getPOC()<< "\t" << getReconMark() << "\t" << getSlice(0)->isReferenced() << "\t" << getIsLongTerm() << "\t" << getOutputMark() << "\t" << getSlice(0)->getPicOutputFlag() <<std::endl;
-}
-
-TComPic* TComPicLists::getPic( Int layerIdInNuh, Int poc )
-{
-  TComPic* pcPic = NULL;
-  for(TComList<TComList<TComPic*>*>::iterator itL = m_lists.begin(); ( itL != m_lists.end() && pcPic == NULL ); itL++)
-  {    
-    for(TComList<TComPic*>::iterator itP=(*itL)->begin(); ( itP!=(*itL)->end() && pcPic == NULL ); itP++)
-    {
-      TComPic* currPic = (*itP); 
-      if ( ( currPic->getPOC() == poc ) && ( currPic->getLayerId() == layerIdInNuh ) )
-      {
-        pcPic = currPic ;      
-      }
-    }
-  }
-  return pcPic;
+Bool TComPic::getPocResetPeriodId()
+{
+  return getSlice(0)->getPocResetIdc(); 
+}
+
+Void TComPic::markAsUsedForShortTermReference()
+{
+  getSlice(0)->setReferenced( true );
+  setIsLongTerm( false ); 
+}
+
+Void TComPic::markAsUsedForLongTermReference()
+{
+  getSlice(0)->setReferenced( true );
+  setIsLongTerm( true ); 
+}
+
+
+Void TComPic::markAsUnusedForReference()
+{
+  getSlice(0)->setReferenced( false );
+  setIsLongTerm( false ); 
+}
+
+
+Bool TComPic::getMarkedUnUsedForReference()
+{
+  return !getSlice(0)->isReferenced( );
+}
+
+
+Bool TComPic::getMarkedAsShortTerm()
+{
+  return ( getSlice(0)->isReferenced( ) && !getIsLongTerm() );
+}
+
+Void TComPic::print( Int outputLevel )
+{
+  if ( outputLevel== 0  )
+  {
+    std::cout  << std::endl 
+      << "LId"
+      << "\t" << "POC"
+      << "\t" << "Rec"
+      << "\t" << "Ref"
+      << "\t" << "LT"
+      << "\t" << "OutMark"
+      << "\t" << "OutFlag" 
+      << "\t" << "Type"
+      << "\t" << "PReFlag"
+      << std::endl;
+  }
+  else if( outputLevel == 1  )
+  {
+    std::cout  << getLayerId()
+      << "\t" << getPOC()
+      << "\t" << getReconMark()
+      << "\t" << getSlice(0)->isReferenced()
+      << "\t" << getIsLongTerm()
+      << "\t" << getOutputMark()
+      << "\t" << getSlice(0)->getPicOutputFlag()
+      << "\t" << getSlice(0)->getNalUnitTypeString()
+      << "\t" << getSlice(0)->getPocResetFlag() 
+      << std::endl;
+  }
+  else if ( outputLevel == 2  )
+  {
+    std::cout  << std:: setfill(' ')
+      << " LayerId: "         << std::setw(2) << getLayerId()
+      << "\t"  << " POC: "             << std::setw(5) << getPOC()
+      << "\t"  << " Dec. Order: "      << std::setw(5) << getDecodingOrder()
+      << "\t"  << " Referenced: "      << std::setw(1) << getSlice(0)->isReferenced()
+      << "\t"  << " Pic type: "        <<                 getSlice(0)->getNalUnitTypeString()
+      << "\t"  << " Generated: "       << std::setw(1) << getIsGenerated()
+      << "\t"  << " Gen. Ref. Pics: "  << std::setw(1) << getHasGeneratedRefPics();
+  }
+  else if ( outputLevel == 4  )
+  {
+    std::cout  << std:: setfill(' ')
+      << " LayerId: "         << std::setw(2) << getLayerId()
+      << "\t"  << " POC: "             << std::setw(5) << getPOC()      
+      << "\t"  << " Referenced: "      << std::setw(1) << getSlice(0)->isReferenced() << std::endl; 
+  }
 }
 
 #if NH_3D
-TComPic* TComPicLists::getPic( Int viewIndex, Bool depthFlag, Int poc )
-{
-  return getPic   ( m_vps->getLayerIdInNuh( viewIndex, depthFlag ), poc );
-}
-#endif
-Void TComPicLists::print()
-{
-  Bool first = true;     
-  for(TComList<TComList<TComPic*>*>::iterator itL = m_lists.begin(); ( itL != m_lists.end() ); itL++)
-  {    
-    for(TComList<TComPic*>::iterator itP=(*itL)->begin(); ( itP!=(*itL)->end() ); itP++)
-    {
-      if ( first )
-      {
-        (*itP)->print( true );       
-        first = false; 
-      }
-      (*itP)->print( false );       
-    }
-  }
-}
-
-TComPicYuv* TComPicLists::getPicYuv( Int layerIdInNuh, Int poc, Bool reconFlag )
-{
-  TComPic*    pcPic = getPic( layerIdInNuh, poc );
-  TComPicYuv* pcPicYuv = NULL;
-
-  if (pcPic != NULL)
-  {
-    if( reconFlag )
-    {
-      if ( pcPic->getReconMark() )
-      {
-        pcPicYuv = pcPic->getPicYuvRec();
-      }
-    }
-    else
-    {
-      pcPicYuv = pcPic->getPicYuvOrg();
-    }
-  };
-
-  return pcPicYuv;
-}
-
-#if NH_3D
-TComPicYuv* TComPicLists::getPicYuv( Int viewIndex, Bool depthFlag, Int poc, Bool recon )
-{  
-  Int layerIdInNuh = m_vps->getLayerIdInNuh( viewIndex, depthFlag ); 
-  return getPicYuv( layerIdInNuh, poc, recon );
-}
-#if NH_3D_ARP
-TComList<TComPic*>* TComPicLists::getPicList( Int layerIdInNuh )
-{
-  TComList<TComList<TComPic*>*>::iterator itL = m_lists.begin();
-  Int iLayer = 0;
-
-  assert( layerIdInNuh < m_lists.size() );
-
-  while( iLayer != layerIdInNuh )
-  {
-    itL++;
-    iLayer++;
-  }
-
-  return *itL;
-}
-#endif
-#endif
-#endif // NH_MV
+Void TComPic::printMotion()
+{
+  TComPicSym* pPicSym = getPicSym();
+  for ( UInt uiCUAddr = 0; uiCUAddr < pPicSym->getNumberOfCtusInFrame(); uiCUAddr++ )
+  {
+    TComDataCU* pCtu = pPicSym->getCtu(uiCUAddr);
+    std::cout << "CUAddr " << uiCUAddr << std::endl; 
+    pCtu->printMV();
+    std::cout << std::endl; 
+  }
+}
 
 #if NH_3D_NBDV 
@@ -437,5 +449,11 @@
           m_abTIVRINCurrRL[curCandPic][iColRefDir][iColRefIdx] = false;
           Int iColViewIdx    = pcCandColSlice->getViewIndex();
+#if H_3D_FIX_ARP_CHECK_NOT_IN_DPB
+          // The picture pcCandColSlice->getRefPic((RefPicList)iColRefDir, iColRefIdx) might not be in DPB anymore
+          // So don't access it directly.
+          Int iColRefViewIdx = pcCandColSlice->getVPS()->getViewOrderIdx( pcCandColSlice->getRefLayerId( (RefPicList)iColRefDir, iColRefIdx ) );       
+#else
           Int iColRefViewIdx = pcCandColSlice->getRefPic((RefPicList)iColRefDir, iColRefIdx)->getViewIndex();
+#endif
           if(iColViewIdx == iColRefViewIdx)
           {
@@ -487,7 +505,7 @@
         {
           if(pcCurrSlice->getRefPOC((RefPicList)iCurrRefDir, iCurrRefIdx ) == iTextRefPOC && 
-             pcCurrSlice->getRefPic((RefPicList)iCurrRefDir, iCurrRefIdx)->getViewIndex() == iTextRefViewId)
+            pcCurrSlice->getRefPic((RefPicList)iCurrRefDir, iCurrRefIdx)->getViewIndex() == iTextRefViewId)
           {  
-            m_aiTexToDepRef[iTextRefDir][iTextRefIdx] = iCurrRefIdx;
+            m_aiTexToDepRef[iTextRefDir][iTextRefIdx] = iCurrRefIdx;            
           }
         }
@@ -504,5 +522,494 @@
 }
 #endif
+#endif
+
+Void TComAu::setPicLatencyCount( Int picLatenyCount )
+{
+  for(TComList<TComPic*>::iterator itP= begin();  itP!= end(); itP++)
+  {      
+    (*itP)->setPicLatencyCount( picLatenyCount ); 
+  }
+}
+
+TComPic* TComAu::getPic( Int nuhLayerId )
+{
+  TComPic* pic = NULL; 
+  for(TComList<TComPic*>::iterator itP= begin(); ( itP!= end() && (pic == NULL) ); itP++)
+  {      
+    if ( (*itP)->getLayerId() == nuhLayerId )
+    {
+      pic = (*itP); 
+    }
+  }
+  return pic;
+}
+
+Void TComAu::addPic( TComPic* pic, Bool pocUnkown )
+{
+  if ( !empty() )
+  {
+    if (!pocUnkown)
+    {
+      assert( pic->getPOC()   == ( getPoc() ));
+    }      
+    pic->setPicLatencyCount( getPicLatencyCount() ); 
+
+    assert( getPic( pic->getLayerId() ) == NULL );
+
+    // Add sorted 
+    TComAu::iterator itP = begin(); 
+    Bool inserted = false; 
+    while( !inserted )
+    {
+      if ( ( itP == end()) || pic->getLayerId() < (*itP)->getLayerId() )
+      {
+        insert(itP, pic ); 
+        inserted = true; 
+      }
+      else
+      {
+        ++itP; 
+      }        
+    }      
+  } 
+  else
+  { 
+    pushBack( pic );      
+  }
+}
+
+Bool TComAu::containsPic( TComPic* pic )
+{
+  Bool isInList = false; 
+  for(TComList<TComPic*>::iterator itP= begin(); ( itP!= end() && (!isInList) ); itP++)
+  { 
+    isInList = isInList || ( pic == (*itP)); 
+  }
+  return isInList;
+}
+
+TComSubDpb::TComSubDpb( Int nuhLayerid )
+{
+  m_nuhLayerId = nuhLayerid;
+}
+
+TComPic* TComSubDpb::getPic( Int poc )
+{
+  TComPic* pic = NULL; 
+  for(TComList<TComPic*>::iterator itP= begin(); ( itP!= end() && (pic == NULL) ); itP++)
+  {      
+    if ( (*itP)->getPOC() == poc )
+    {
+      pic = (*itP); 
+    }
+  }
+  return pic;
+}
+
+TComPic* TComSubDpb::getPicFromLsb( Int pocLsb, Int maxPicOrderCntLsb )
+{
+  TComPic* pic = NULL; 
+  for(TComList<TComPic*>::iterator itP= begin(); ( itP!= end() && (pic == NULL) ); itP++)
+  {      
+    if ( ( (*itP)->getPOC() & ( maxPicOrderCntLsb - 1 ) ) == pocLsb )
+    {
+      pic = (*itP); 
+    }
+  }
+  return pic;
+}
+
+TComPic* TComSubDpb::getShortTermRefPic( Int poc )
+{
+  TComPic* pic = NULL; 
+  for(TComList<TComPic*>::iterator itP= begin(); ( itP!= end() && (pic == NULL) ); itP++)
+  {      
+    if ( (*itP)->getPOC() == poc && (*itP)->getMarkedAsShortTerm() )
+    {
+      pic = (*itP); 
+    }
+  }
+  return pic;
+}
+
+TComList<TComPic*> TComSubDpb::getPicsMarkedNeedForOutput()
+{
+  TComList<TComPic*> picsMarkedNeedForOutput; 
+
+  for(TComList<TComPic*>::iterator itP= begin();  itP!= end() ; itP++ )
+  {      
+    if ( (*itP)->getOutputMark() )
+    {
+      picsMarkedNeedForOutput.push_back( (*itP) );
+    }
+  }
+  return picsMarkedNeedForOutput;
+}
+
+Void TComSubDpb::markAllAsUnusedForReference()
+{
+  for(TComList<TComPic*>::iterator itP= begin();  itP!= end() ; itP++ )
+  {      
+    (*itP)->markAsUnusedForReference(); 
+  }
+}
+
+Void TComSubDpb::addPic( TComPic* pic )
+{
+  assert( pic != NULL ); 
+  assert( m_nuhLayerId == pic->getLayerId() || m_nuhLayerId == -1);      
+  if ( !empty() )
+  {
+    assert( getPic( pic->getPOC() ) == NULL ); // Don't add twice; assert( pic->getLayerId() == m_nuhLayerId );            
+
+    // Add sorted 
+    TComSubDpb::iterator itP = begin(); 
+    Bool inserted = false; 
+    while( !inserted )
+    {
+      if ( ( itP == end()) || pic->getPOC() < (*itP)->getPOC() )
+      {
+        insert(itP, pic ); 
+        inserted = true; 
+      }
+      else
+      {
+        ++itP; 
+      }        
+    }      
+  } 
+  else
+  { 
+    pushBack( pic );
+  }
+}
+
+Void TComSubDpb::removePics( std::vector<TComPic*> picToRemove )
+{
+  for (Int i = 0; i < picToRemove.size(); i++ )
+  {
+    if( picToRemove[i] != NULL)
+    {
+      remove( picToRemove[i] ); 
+    }
+  }
+}
+
+Bool TComSubDpb::areAllPicsMarkedNotNeedForOutput()
+{
+  return ( getPicsMarkedNeedForOutput().size() == 0 );
+}
+
+
+TComPicLists::~TComPicLists()
+{
+  emptyAllSubDpbs();
+  for(TComList<TComSubDpb*>::iterator itL = m_subDpbs.begin(); ( itL != m_subDpbs.end()); itL++)
+  {      
+    if ( (*itL) != NULL )
+    {
+      delete (*itL); 
+      (*itL) = NULL; 
+    }
+  }
+}
+
+Void TComPicLists::addNewPic( TComPic* pic )
+{
+  getSubDpb ( pic->getLayerId() , true )->addPic( pic ); 
+  getAu     ( pic->getPOC()     , true )->addPic( pic , false ); 
+  if ( m_printPicOutput )
+  {
+    std::cout << "  Add    picture: ";
+    pic->print( 2 );
+    std::cout << std::endl;
+  }
+}
+
+Void TComPicLists::removePic( TComPic* pic )
+{
+  if (pic != NULL)
+  {
+
+    TComSubDpb* curSubDpb = getSubDpb( pic->getLayerId(), false ); 
+    curSubDpb->remove( pic );
+
+    TComAu* curAu = getAu     ( pic->getPOC(), false );       
+
+    if (curAu != NULL)
+    {    
+      curAu->remove( pic );
+      // Remove AU when empty. 
+      if (curAu->empty() )
+      {
+        m_aus.remove( curAu ); 
+        delete curAu; 
+      }
+    }
+
+    if ( m_printPicOutput )
+    {
+      std::cout << "  Remove picture: ";
+      pic->print( 2 );
+      std::cout << std::endl;
+    }
+
+    pic->destroy();
+    delete pic; 
+  }
+}
+
+TComPic* TComPicLists::getPic( Int layerIdInNuh, Int poc )
+{
+  TComPic* pcPic = NULL;
+  TComSubDpb* subDpb = getSubDpb( layerIdInNuh, false ); 
+  if ( subDpb != NULL )
+  {
+    pcPic = subDpb->getPic( poc ); 
+  }
+  return pcPic;
+}
+
+TComPicYuv* TComPicLists::getPicYuv( Int layerIdInNuh, Int poc, Bool reconFlag )
+{
+  TComPic*    pcPic = getPic( layerIdInNuh, poc );
+  TComPicYuv* pcPicYuv = NULL;
+
+  if (pcPic != NULL)
+  {
+    if( reconFlag )
+    {
+      if ( pcPic->getReconMark() )
+      {
+        pcPicYuv = pcPic->getPicYuvRec();
+      }
+    }
+    else
+    {
+      pcPicYuv = pcPic->getPicYuvOrg();
+    }
+  };
+
+  return pcPicYuv;
+}
+
+TComSubDpb* TComPicLists::getSubDpb( Int nuhLayerId, Bool create )
+{
+  TComSubDpb* subDpb = NULL;
+  for(TComList<TComSubDpb*>::iterator itL = m_subDpbs.begin(); ( itL != m_subDpbs.end() && subDpb == NULL ); itL++)
+  {      
+    if ( (*itL)->getLayerId() == nuhLayerId )
+    {        
+      subDpb = (*itL); 
+    }
+  }  
+  if ( subDpb == NULL && create )
+  {
+    m_subDpbs.push_back( new TComSubDpb(nuhLayerId) ); 
+  }
+  return subDpb;
+}
+
+TComList<TComSubDpb*>* TComPicLists::getSubDpbs()
+{
+  return (&m_subDpbs);
+}
+
+TComAu* TComPicLists::addAu( Int poc )
+{
+  TComList<TComAu*>::iterator itA = m_aus.begin(); 
+
+  assert( getAu(poc, false) == NULL );
+  Bool inserted = false; 
+  while( !inserted)
+  {      
+    if ( ( itA == m_aus.end()) || poc < (*itA)->getPoc() )
+    {        
+      m_aus.insert(itA, new TComAu );        
+      inserted = true; 
+      --itA; 
+    }
+    else
+    {
+      ++itA; 
+    }
+  }
+  return (*itA);
+}
+
+TComAu* TComPicLists::getAu( Int poc, Bool create )
+{
+  TComAu* au = NULL;
+
+  for( TComList<TComAu*>::iterator itA = m_aus.begin(); ( itA != m_aus.end() && au == NULL ); itA++)
+  { 
+    if ( (*itA)->getPoc() == poc )
+    {        
+      au = (*itA); 
+    }
+  }  
+
+  if ( au == NULL && create )
+  {
+    au = addAu( poc ); 
+  }
+  return au;
+}
+
+TComList<TComAu*>* TComPicLists::getAus()
+{
+  return (&m_aus);
+}
+
+TComList<TComAu*> TComPicLists::getAusHavingPicsMarkedForOutput()
+{
+  TComList<TComAu*> ausHavingPicsForOutput; 
+  for(TComList<TComAu*>::iterator itA= m_aus.begin(); ( itA!=m_aus.end()); itA++)
+  {
+    Bool hasPicMarkedAsNeedForOutput = false;
+    for( TComAu::iterator itP= (*itA)->begin(); (itP!=(*itA)->end() && !hasPicMarkedAsNeedForOutput); itP++  )
+    {
+      if( (*itP)->getOutputMark() )
+      {
+        hasPicMarkedAsNeedForOutput = true; 
+      }
+    }
+    if (hasPicMarkedAsNeedForOutput)
+    {
+      ausHavingPicsForOutput.pushBack( (*itA) );
+    }
+  }
+  return ausHavingPicsForOutput;
+}
+
+Void TComPicLists::markSubDpbAsUnusedForReference( Int layerIdInNuh )
+{
+  TComSubDpb* subDpb = getSubDpb( layerIdInNuh, false ); 
+  markSubDpbAsUnusedForReference( *subDpb );
+}
+
+Void TComPicLists::markSubDpbAsUnusedForReference( TComSubDpb& subDpb )
+{
+  for(TComList<TComPic*>::iterator itP=subDpb.begin(); ( itP!=subDpb.end()); itP++)
+  {
+    (*itP)->markAsUnusedForReference(); 
+  }
+}
+
+Void TComPicLists::markAllSubDpbAsUnusedForReference()
+{
+  for(TComList<TComSubDpb*>::iterator itS= m_subDpbs.begin(); ( itS!=m_subDpbs.end()); itS++)
+  {
+    markSubDpbAsUnusedForReference( *(*itS) ); 
+  }
+}
+
+Void TComPicLists::decrementPocsInSubDpb( Int nuhLayerId, Int deltaPocVal )
+{
+  TComSubDpb* subDpb = getSubDpb( nuhLayerId, false ); 
+
+  for(TComSubDpb::iterator itP = subDpb->begin(); itP!=subDpb->end(); itP++)
+  {
+    TComPic* pic = (*itP); 
+    for (Int i = 0; i < pic->getNumAllocatedSlice(); i++)
+    {
+      TComSlice* slice = pic->getSlice(i);
+      slice->setPOC( slice->getPOC() - deltaPocVal ); 
+    }    
+  }
+}
+Void TComPicLists::emptyAllSubDpbs()
+{
+  emptySubDpbs( &m_subDpbs );
+}
+
+Void TComPicLists::emptySubDpbs( TComList<TComSubDpb*>* subDpbs )
+{
+  assert( subDpbs != NULL ); 
+  for( TComList<TComSubDpb*>::iterator itS = subDpbs->begin(); itS != subDpbs->end(); itS++ )
+  {
+    emptySubDpb( (*itS) ); 
+  }
+}
+
+Void TComPicLists::emptySubDpb( TComSubDpb* subDpb )
+{
+  if(subDpb != NULL)
+  {
+    while( !subDpb->empty() )
+    {
+      TComPic* curPic = *(subDpb->begin()); 
+      removePic( curPic ); 
+    }
+  }
+}
+
+Void TComPicLists::emptySubDpb( Int nuhLayerId )
+{
+  emptySubDpb( getSubDpb( nuhLayerId , false) );
+}
+
+Void TComPicLists::emptyNotNeedForOutputAndUnusedForRef()
+{
+  for(TComList<TComSubDpb*>::iterator itS= m_subDpbs.begin(); ( itS!=m_subDpbs.end()); itS++)
+  {
+    emptySubDpbNotNeedForOutputAndUnusedForRef( *(*itS) ); 
+  }
+}
+
+Void TComPicLists::emptySubDpbNotNeedForOutputAndUnusedForRef( Int layerId )
+{
+  TComSubDpb* subDpb = getSubDpb( layerId, false ); 
+  emptySubDpbNotNeedForOutputAndUnusedForRef( *subDpb );
+}
+
+Void TComPicLists::emptySubDpbNotNeedForOutputAndUnusedForRef( TComSubDpb subDpb )
+{
+  for(TComSubDpb::iterator itP= subDpb.begin(); ( itP!=subDpb.end()); itP++)
+  {
+    TComPic* pic = (*itP); 
+    if ( !pic->getOutputMark() && pic->getMarkedUnUsedForReference() )
+    {
+      removePic( pic ); 
+    }
+  }
+}
+
+Void TComPicLists::print()
+{
+  Bool first = true;     
+  for(TComList<TComSubDpb*>::iterator itL = m_subDpbs.begin(); ( itL != m_subDpbs.end() ); itL++)
+  {    
+    for(TComList<TComPic*>::iterator itP=(*itL)->begin(); ( itP!=(*itL)->end() ); itP++)
+    {
+      if ( first )
+      {
+        (*itP)->print( true );       
+        first = false; 
+      }
+      (*itP)->print( false );       
+    }
+  }
+}
+
+#if NH_3D
+TComPicYuv* TComPicLists::getPicYuv( Int viewIndex, Bool depthFlag, Int poc, Bool recon )
+{  
+  Int layerIdInNuh = m_vps->getLayerIdInNuh( viewIndex, depthFlag ); 
+  return getPicYuv( layerIdInNuh, poc, recon );
+}
+
+TComPic* TComPicLists::getPic( Int viewIndex, Bool depthFlag, Int poc )
+{
+  return getPic   ( m_vps->getLayerIdInNuh( viewIndex, depthFlag ), poc );
+}
+
+#endif
+
+#endif
+
+
 
 
 //! \}
+
